<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>GLES 2.0 context</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-integration.html" title="Binding and Integrating">
<link rel="prev" href="cogl-2.0-experimental-GType-Integration-API.html" title="GType Integration API">
<link rel="next" href="coglglossary.html" title="Glossaries">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-GType-Integration-API.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-integration.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="coglglossary.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-GLES-2.0-context.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-GLES-2.0-context.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-GLES-2.0-context"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-GLES-2.0-context.top_of_page"></a>GLES 2.0 context</span></h2>
<p>GLES 2.0 context — A portable api to access OpenGLES 2.0</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-GLES-2.0-context.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context">CoglGLES2Context</a>;
struct              <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable">CoglGLES2Vtable</a>;
#define             <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#COGL-GLES2-CONTEXT-ERROR:CAPS" title="COGL_GLES2_CONTEXT_ERROR">COGL_GLES2_CONTEXT_ERROR</a>
enum                <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2ContextError" title="enum CoglGLES2ContextError">CoglGLES2ContextError</a>;
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="returnvalue">CoglGLES2Context</span></a> *  <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-context-new" title="cogl_gles2_context_new ()">cogl_gles2_context_new</a>              (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-is-gles2-context" title="cogl_is_gles2_context ()">cogl_is_gles2_context</a>               (<em class="parameter"><code><span class="type">void</span> *object</code></em>);

const <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="returnvalue">CoglGLES2Vtable</span></a> * <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-context-get-vtable" title="cogl_gles2_context_get_vtable ()">cogl_gles2_context_get_vtable</a>   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> *gles2_ctx</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-push-gles2-context" title="cogl_push_gles2_context ()">cogl_push_gles2_context</a>             (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> *gles2_ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> *read_buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> *write_buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-pop-gles2-context" title="cogl_pop_gles2_context ()">cogl_pop_gles2_context</a>              (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>);
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="returnvalue">CoglGLES2Vtable</span></a> *   <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-get-current-vtable" title="cogl_gles2_get_current_vtable ()">cogl_gles2_get_current_vtable</a>       (<em class="parameter"><code><span class="type">void</span></code></em>);

<a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="returnvalue">CoglTexture2D</span></a> *     <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-texture-2d-new-from-handle" title="cogl_gles2_texture_2d_new_from_handle ()">cogl_gles2_texture_2d_new_from_handle</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> *gles2_ctx</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> handle</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglPixelFormat" title="enum CoglPixelFormat"><span class="type">CoglPixelFormat</span></a> internal_format</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-texture-get-handle" title="cogl_gles2_texture_get_handle ()">cogl_gles2_texture_get_handle</a>       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a> *texture</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> *handle</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> *target</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-GLES-2.0-context.description"></a><h2>Description</h2>
<p>
Cogl provides portable access to the OpenGLES api through a single
library that is able to smooth over inconsistencies between the
different vendor drivers for OpenGLES in a single place.
</p>
<p>
The api is designed to allow Cogl to transparently implement the
api on top of other drivers, such as OpenGL, D3D or on Cogl's own
drawing api so even if your platform doesn't come with an
OpenGLES 2.0 api Cogl may still be able to expose the api to your
application.
</p>
<p>
Since Cogl is a library and not an api specification it is possible
to add OpenGLES 2.0 api features to Cogl which can immidiately
benefit developers regardless of what platform they are running on.
</p>
<p>
With this api it's possible to re-use existing OpenGLES 2.0 code
within applications that are rendering with the Cogl API and also
it's possible for applications that render using OpenGLES 2.0 to
incorporate content rendered with Cogl.
</p>
<p>
Applications can check for OpenGLES 2.0 api support by checking for
<a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#COGL-FEATURE-ID-GLES2-CONTEXT:CAPS"><code class="literal">COGL_FEATURE_ID_GLES2_CONTEXT</code></a> support with <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#cogl-has-feature" title="cogl_has_feature ()"><code class="function">cogl_has_feature()</code></a>.
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-GLES-2.0-context.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglGLES2Context"></a><h3>CoglGLES2Context</h3>
<pre class="programlisting">typedef struct _CoglGLES2Context CoglGLES2Context;</pre>
<p>
Represents an OpenGLES 2.0 api context used as a sandbox for
OpenGLES 2.0 state. This is comparable to an EGLContext for those
who have used OpenGLES 2.0 with EGL before.
</p>
<p class="since">Since 1.12</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglGLES2Vtable"></a><h3>struct CoglGLES2Vtable</h3>
<pre class="programlisting">struct CoglGLES2Vtable {
};
</pre>
<p>
Provides function pointers for the full OpenGLES 2.0 api. The
api must be accessed this way and not by directly calling
symbols of any system OpenGLES 2.0 api.
</p>
<p class="since">Since 1.12</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="COGL-GLES2-CONTEXT-ERROR:CAPS"></a><h3>COGL_GLES2_CONTEXT_ERROR</h3>
<pre class="programlisting">#define COGL_GLES2_CONTEXT_ERROR (_cogl_gles2_context_error_quark ())
</pre>
<p>
An error domain for runtime exceptions relating to the
cogl_gles2_context api.
</p>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglGLES2ContextError"></a><h3>enum CoglGLES2ContextError</h3>
<pre class="programlisting">typedef enum {
 /*&lt; prefix=COGL_GLES2_CONTEXT_ERROR &gt;*/
  COGL_GLES2_CONTEXT_ERROR_UNSUPPORTED,
  COGL_GLES2_CONTEXT_ERROR_DRIVER
} CoglGLES2ContextError;
</pre>
<p>
Error codes that relate to the cogl_gles2_context api.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><a name="COGL-GLES2-CONTEXT-ERROR-UNSUPPORTED:CAPS"></a><span class="term"><code class="literal">COGL_GLES2_CONTEXT_ERROR_UNSUPPORTED</code></span></p></td>
<td>Creating GLES2 contexts
   isn't supported. Applications should use <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#cogl-has-feature" title="cogl_has_feature ()"><code class="function">cogl_has_feature()</code></a> to
   check for the <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#COGL-FEATURE-ID-GLES2-CONTEXT:CAPS"><code class="literal">COGL_FEATURE_ID_GLES2_CONTEXT</code></a>.
</td>
</tr>
<tr>
<td><p><a name="COGL-GLES2-CONTEXT-ERROR-DRIVER:CAPS"></a><span class="term"><code class="literal">COGL_GLES2_CONTEXT_ERROR_DRIVER</code></span></p></td>
<td>An underlying driver error
   occured.
</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-gles2-context-new"></a><h3>cogl_gles2_context_new ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="returnvalue">CoglGLES2Context</span></a> *  cogl_gles2_context_new              (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);</pre>
<p>
Allocates a new OpenGLES 2.0 context that can be used to render to
<a class="link" href="cogl-2.0-experimental-Offscreen-Framebuffers.html#CoglOffscreen" title="CoglOffscreen"><span class="type">CoglOffscreen</span></a> framebuffers (Rendering to <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a>
framebuffers is not currently supported).
</p>
<p>
To actually access the OpenGLES 2.0 api itself you need to use
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-context-get-vtable" title="cogl_gles2_context_get_vtable ()"><code class="function">cogl_gles2_context_get_vtable()</code></a>. You should not try to directly link
to and use the symbols provided by the a system OpenGLES 2.0
driver.
</p>
<p>
Once you have allocated an OpenGLES 2.0 context you can make it
current using <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-push-gles2-context" title="cogl_push_gles2_context ()"><code class="function">cogl_push_gles2_context()</code></a>. For those familiar with
using the EGL api, this serves a similar purpose to eglMakeCurrent.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Before using this api applications can check for OpenGLES 2.0
api support by checking for <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#COGL-FEATURE-ID-GLES2-CONTEXT:CAPS"><code class="literal">COGL_FEATURE_ID_GLES2_CONTEXT</code></a> support
with <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#cogl-has-feature" title="cogl_has_feature ()"><code class="function">cogl_has_feature()</code></a>. This function will return <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> and
return an <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#COGL-GLES2-CONTEXT-ERROR-UNSUPPORTED:CAPS"><code class="literal">COGL_GLES2_CONTEXT_ERROR_UNSUPPORTED</code></a> error if the
feature isn't available.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>ctx</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>error</code></em> :</span></p></td>
<td>A pointer to a <a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> for returning exceptions</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A newly allocated <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> or <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> if there
was an error and <em class="parameter"><code>error</code></em> will be updated in that case.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-gles2-context"></a><h3>cogl_is_gles2_context ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_gles2_context               (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Gets whether the given object references a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglObject" title="CoglObject"><span class="type">CoglObject</span></a> pointer</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the object references a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a>
and <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-gles2-context-get-vtable"></a><h3>cogl_gles2_context_get_vtable ()</h3>
<pre class="programlisting">const <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="returnvalue">CoglGLES2Vtable</span></a> * cogl_gles2_context_get_vtable   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> *gles2_ctx</code></em>);</pre>
<p>
Queries the OpenGLES 2.0 api function pointers that should be
used for rendering with the given <em class="parameter"><code>gles2_ctx</code></em>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>You should not try to directly link to and use the symbols
provided by any system OpenGLES 2.0 driver.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>gles2_ctx</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> allocated with
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-context-new" title="cogl_gles2_context_new ()"><code class="function">cogl_gles2_context_new()</code></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A pointer to a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="type">CoglGLES2Vtable</span></a> providing pointers
to functions for the full OpenGLES 2.0 api.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-push-gles2-context"></a><h3>cogl_push_gles2_context ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_push_gles2_context             (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> *gles2_ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> *read_buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> *write_buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);</pre>
<p>
Pushes the given <em class="parameter"><code>gles2_ctx</code></em> onto a stack associated with <em class="parameter"><code>ctx</code></em> so
that the OpenGLES 2.0 api can be used instead of the Cogl
rendering apis to read and write to the specified framebuffers.
</p>
<p>
Usage of the api available through a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="type">CoglGLES2Vtable</span></a> is only
allowed between <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-push-gles2-context" title="cogl_push_gles2_context ()"><code class="function">cogl_push_gles2_context()</code></a> and
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-pop-gles2-context" title="cogl_pop_gles2_context ()"><code class="function">cogl_pop_gles2_context()</code></a> calls.
</p>
<p>
If there is a runtime problem with switching over to the given
<em class="parameter"><code>gles2_ctx</code></em> then this function will return <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> and return
an error through <em class="parameter"><code>error</code></em>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>ctx</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>gles2_ctx</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> allocated with
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-context-new" title="cogl_gles2_context_new ()"><code class="function">cogl_gles2_context_new()</code></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>read_buffer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> to access to read operations
such as glReadPixels. (must be a <a class="link" href="cogl-2.0-experimental-Offscreen-Framebuffers.html#CoglOffscreen" title="CoglOffscreen"><span class="type">CoglOffscreen</span></a>
framebuffer currently)</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>write_buffer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> to access for drawing operations
such as glDrawArrays. (must be a <a class="link" href="cogl-2.0-experimental-Offscreen-Framebuffers.html#CoglOffscreen" title="CoglOffscreen"><span class="type">CoglOffscreen</span></a>
framebuffer currently)</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>error</code></em> :</span></p></td>
<td>A pointer to a <a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> for returning exceptions</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if operation was successfull or <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>
otherwise and <em class="parameter"><code>error</code></em> will be updated.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-pop-gles2-context"></a><h3>cogl_pop_gles2_context ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_pop_gles2_context              (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>);</pre>
<p>
Restores the previously active <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> if there
were nested calls to <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-push-gles2-context" title="cogl_push_gles2_context ()"><code class="function">cogl_push_gles2_context()</code></a> or otherwise
restores the ability to render with the Cogl api instead
of OpenGLES 2.0.
</p>
<p>
The behaviour is undefined if calls to <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-pop-gles2-context" title="cogl_pop_gles2_context ()"><code class="function">cogl_pop_gles2_context()</code></a>
are not balenced with the number of corresponding calls to
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-push-gles2-context" title="cogl_push_gles2_context ()"><code class="function">cogl_push_gles2_context()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>ctx</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-gles2-get-current-vtable"></a><h3>cogl_gles2_get_current_vtable ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="returnvalue">CoglGLES2Vtable</span></a> *   cogl_gles2_get_current_vtable       (<em class="parameter"><code><span class="type">void</span></code></em>);</pre>
<p>
Returns the OpenGL ES 2.0 api vtable for the currently pushed
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> (last pushed with <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-push-gles2-context" title="cogl_push_gles2_context ()"><code class="function">cogl_push_gles2_context()</code></a>) or
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> if no <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> has been pushed.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>The <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="type">CoglGLES2Vtable</span></a> for the currently pushed
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> or <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> if none has been pushed.</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-gles2-texture-2d-new-from-handle"></a><h3>cogl_gles2_texture_2d_new_from_handle ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="returnvalue">CoglTexture2D</span></a> *     cogl_gles2_texture_2d_new_from_handle
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *ctx</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> *gles2_ctx</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> handle</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglPixelFormat" title="enum CoglPixelFormat"><span class="type">CoglPixelFormat</span></a> internal_format</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);</pre>
<p>
Creates a <a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="type">CoglTexture2D</span></a> from an OpenGL ES 2.0 texture handle that
was created within the given <em class="parameter"><code>gles2_ctx</code></em> via <code class="function">glGenTextures()</code>. The
texture needs to have been associated with the GL_TEXTURE_2D target.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>This interface is only intended for sharing textures to read
from.  The behaviour is undefined if the texture is modified using
the Cogl api.</div>
<p>
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Applications should only pass this function handles that were
created via a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="type">CoglGLES2Vtable</span></a> or via libcogl-gles2 and not pass
handles created directly using the system's native libGLESv2
api.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>ctx</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>gles2_ctx</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> allocated with
<a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-context-new" title="cogl_gles2_context_new ()"><code class="function">cogl_gles2_context_new()</code></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>handle</code></em> :</span></p></td>
<td>An OpenGL ES 2.0 texture handle created with
<code class="function">glGenTextures()</code>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>width</code></em> :</span></p></td>
<td>Width of the texture to allocate</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>height</code></em> :</span></p></td>
<td>Height of the texture to allocate</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>internal_format</code></em> :</span></p></td>
<td>The format of the texture</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>error</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> for exceptions</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-gles2-texture-get-handle"></a><h3>cogl_gles2_texture_get_handle ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_gles2_texture_get_handle       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a> *texture</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> *handle</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> *target</code></em>);</pre>
<p>
Gets an OpenGL ES 2.0 texture handle for a <a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a> that can
then be referenced by a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a>. As well as returning
a texture handle the texture's target (such as GL_TEXTURE_2D) is
also returned.
</p>
<p>
If the <a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a> can not be shared with a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> then
this function will return <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>.
</p>
<p>
This api does not affect the lifetime of the CoglTexture and you
must take care not to reference the returned handle after the
original texture has been freed.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>This interface is only intended for sharing textures to read
from.  The behaviour is undefined if the texture is modified by a
GLES2 context.</div>
<p>
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>This function will only return <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> for low-level
<a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a>s such as <a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="type">CoglTexture2D</span></a> or <a class="link" href="cogl-2.0-experimental-3D-textures.html#CoglTexture3D" title="CoglTexture3D"><span class="type">CoglTexture3D</span></a> but
not for high level meta textures such as
<a class="link" href="cogl-2.0-experimental-Sliced-Textures.html#CoglTexture2DSliced" title="CoglTexture2DSliced"><span class="type">CoglTexture2DSliced</span></a>
</div>
<p>
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>The handle returned should not be passed directly to a system
OpenGL ES 2.0 library, the handle is only intended to be used via
a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Vtable" title="struct CoglGLES2Vtable"><span class="type">CoglGLES2Vtable</span></a> or via libcogl-gles2.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>texture</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>handle</code></em> :</span></p></td>
<td>A return location for an OpenGL ES 2.0 texture handle</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>target</code></em> :</span></p></td>
<td>A return location for an OpenGL ES 2.0 texture target</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if a handle and target could be returned
otherwise <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> is returned.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>